#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import variable
from algo_left_line import Algo_left_line


class Algo_code():

    # Read Key, from left to the right
    def algo_code(pix, stKey, i_add, stFormat):

        iCount = 0
        i_count_loop = 0

        loop = int(variable.loop)

        if loop == 0:
            return

        while i_count_loop < loop:

            # Key for 1350 x 900
            if stFormat == "900":

                i_width = int(stKey[0 + iCount: 3 + iCount])
                i_height = int(stKey[3 + iCount: 6 + iCount])
                iSquare = int(stKey[6 + iCount: 9 + iCount])

                iCount += 9

            # 160 / 4 = 40 bit
            elif stFormat == "160":

                i_width = int(stKey[0 + iCount: 3 + iCount])
                i_height = int(stKey[3 + iCount: 6 + iCount])
                iSquare = int(stKey[6 + iCount: 9 + iCount])

                iCount += 9

                i_width = i_width * 4
                i_height = i_height * 4
                iSquare = iSquare * 4

            else:
                # not sure format: 3840 x 2160
                i_width = int(stKey[0 + iCount: 4 + iCount])
                i_height = int(stKey[4 + iCount: 8 + iCount])
                iSquare = int(stKey[8 + iCount: 12 + iCount])

                iCount += 12

            if stFormat == "900":

                # iAdd is for the second code with one pixel more for X and for Y

                Algo_left_line.algo_left_line(pix, i_width + i_add, i_height + i_add, iSquare)

            # 160 / 4 = 40 bit
            elif stFormat == "160":

                # iAdd is for the second code with one pixel more for X and for Y
                if i_add == 1:
                    i_add = 4

                try:
                    # keep it for debug
                    #print(f"i_width : {i_width}, i_height : {i_height}, iSquare : {iSquare}, i_add : {i_add}")

                    # keep it for debug
                    # max value is 236
                    # 236 + i_add 4 = 240
                    #print(i_width + iSquare)


                    # four time because one pixel is represented with 4 px X 4 px
                    Algo_left_line.algo_left_line(pix, i_width + i_add, i_height + i_add, iSquare)

                    Algo_left_line.algo_left_line(pix, i_width + 1 + i_add, i_height + 1 + i_add, iSquare - 2)

                    Algo_left_line.algo_left_line(pix, i_width + 2 + i_add, i_height + 2 + i_add, iSquare - 4)

                    Algo_left_line.algo_left_line(pix, i_width + 3 + i_add, i_height + 3 + i_add, iSquare - 6)

                except:

                    print(f"Error at << algo_left_line >> : i_width : {i_width}, i_height : {i_height}, iSquare : {iSquare}")


            else:
                # turn a square (as line from 4px width) with 16 pixels - side 4 px X 4 px
                # not sure: 3840 x 2160
                Algo_left_line.algo_left_line(pix, i_width + i_add, i_height + i_add, iSquare)

                Algo_left_line.algo_left_line(pix, i_width + 1 + i_add, i_height + 1 + i_add, iSquare - 2)

                Algo_left_line.algo_left_line(pix, i_width + 2 + i_add, i_height + 2 + i_add, iSquare - 4)

                Algo_left_line.algo_left_line(pix, i_width + 3 + i_add, i_height + 3 + i_add, iSquare - 6)

            i_count_loop += 1
