#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import os
import tempfile
from pathlib import Path
from PIL import Image
from os.path import isfile, join
import variable
from algo_code import Algo_code
from implement_binary import Implement_binary
from format_size_picture import Format_size_picture
from variable import list_format


#  _   _                                                       _        _
# | |_| |__   ___   _ __   __ _ _ __ ___   ___    ___ ___   __| | ___  (_)___
# | __| '_ \ / _ \ | '_ \ / _` | '_ ` _ \ / _ \  / __/ _ \ / _` |/ _ \ | / __|
# | |_| | | |  __/ | | | | (_| | | | | | |  __/ | (_| (_) | (_| |  __/ | \__ \
#  \__|_| |_|\___| |_| |_|\__,_|_| |_| |_|\___|  \___\___/ \__,_|\___| |_|___/
#
#                  _    _                                __ _ _      _
#  _ __ ___   __ _| | _(_)_ __   __ _    ___ ___  _ __  / _| (_) ___| |_
# | '_ ` _ \ / _` | |/ / | '_ \ / _` |  / __/ _ \| '_ \| |_| | |/ __| __|
# | | | | | | (_| |   <| | | | | (_| | | (_| (_) | | | |  _| | | (__| |_
# |_| |_| |_|\__,_|_|\_\_|_| |_|\__, |  \___\___/|_| |_|_| |_|_|\___|\__|
#                               |___/
#           _ _   _                   _   _
# __      _(_) |_| |__    _ __  _   _| |_| |__   ___  _ __
# \ \ /\ / / | __| '_ \  | '_ \| | | | __| '_ \ / _ \| '_ \
#  \ V  V /| | |_| | | | | |_) | |_| | |_| | | | (_) | | | |
#   \_/\_/ |_|\__|_| |_| | .__/ \__, |\__|_| |_|\___/|_| |_|
#                        |_|    |___/


class Code_k():

    def code_k(self, str_answer, path_dir_code_decode, path_dir_destination_after_code_for_voice):


        dirs = os.listdir(path_dir_code_decode)

        nothing_to_code = True

        # all the files and directories
        for file_name in dirs:

            path_file = join(path_dir_code_decode, file_name)


            # only files
            if isfile(path_file):


                if "." in file_name and len(file_name) > 4:

                    index = file_name.find('_')

                    last_index = file_name.rfind('.')
                    # print("last_index ", last_index)

                    # png_ will be png
                    str_beginn_before_underscore = file_name[:index].lower()

                    # png or gif
                    str_extension = file_name[last_index + 1:].lower()

                    file_name_without_extension = file_name[:last_index]


                    # do not take files already coded
                    if str_beginn_before_underscore not in list_format and str_extension in list_format:

                        # gif 1350 x 900
                        if "0" in str_answer:


                            print(f"will code {file_name}")

                            nothing_to_code = False


                            # Execute xxd
                            # file: /tmp/kodbild.tmp
                            #                                                           *
                            # xxd is a Linux Shell command to convert a file in a hexadecimal
                            # representation
                            #                                                           *
                            # Example (one row is 60 hex. chars -> 30 Bytes):
                            # 0a0a0a48616c6c6f20426173746920756e642048656c6c692c0a0a496368
                            # 2077c3bc6e7363686520657563682065696e656e206672c3b66865205765
                            # 6963686e61636874656e21200a0a5669656c6520467265756e64652c2045
                            # 72666f6c6720756e6420476573756e64686569742066c3bc722032303139
                            # 2e0a0a45757265204a6f68616e6e0a

                            os.system(f'xxd -p {path_file} >/tmp/kodbild.tmp')


                            i_width_model = 1350
                            i_height_model = 900

                            # current temporary (tmp) directory on Linux and wn
                            path_dir_temp = (tempfile.gettempdir())

                            path_file_tmp = os.path.join(path_dir_temp, "kodbild.tmp")

                            file_tmp = open(path_file_tmp, "r")

                            try:
                                str_hexa_all = ""
                                for line in file_tmp:

                                    # '000000000000000000000000000000\n' will be '000000000000000000000000000000'
                                    str_text = line.strip()

                                    str_hexa_all += str_text
                            except:
                                print("Put all hexadecimal in string is not possible")


                            # Paste the Binary of the OGG File - Black for one and white for zero - in the
                            # PNG For the last PNG - Black for one and yellow for zero
                            object_implement = Implement_binary()

                            if path_dir_destination_after_code_for_voice != "":
                                path_dir_code_decode = path_dir_destination_after_code_for_voice

                            object_implement.implement_binary(str_hexa_all, i_width_model,i_height_model, file_name_without_extension, str_extension, path_dir_code_decode, str_answer)

                            # delete only in normal mode
                            if path_dir_destination_after_code_for_voice == "":
                                try:
                                    os.remove(path_file)
                                except:
                                    print(f"cannot remove {path_file}")

                        # mixing pixel 1350 x 900 - only possible with png format
                        elif "1" in str_answer and str_extension == "png":

                            print(f"will code {file_name}")

                            nothing_to_code = False

                            im = Image.open(path_file)

                            w, h = im.size

                            if w != 1350 or h != 900:
                                im.close
                                obj_Format_size_picture = Format_size_picture()
                                obj_Format_size_picture.format_size_picture(path_file)
                                im = Image.open(path_file)


                            pix = im.load()

                            Algo_code.algo_code(pix, variable.key_900_1, 0, "900")
                            Algo_code.algo_code(pix, variable.key_900_1, 1, "900")
                            Algo_code.algo_code(pix, variable.key_900_2, 0, "900")
                            Algo_code.algo_code(pix, variable.key_900_2, 1, "900")

                            name_file_after_code = f"{str_extension}_{file_name}"

                            path_file_png = join(path_dir_code_decode, name_file_after_code)

                            im.save(path_file_png)

                            try:
                                os.remove(path_file)
                            except:
                                print(f"cannot remove {path_file}")

                        # gif - format 60 x 40
                        elif "2" in str_answer:

                            print(f"will code {file_name}")

                            nothing_to_code = False

                            # Execute xxd
                            # file: /tmp/kodbild.tmp
                            #                                                           *
                            # xxd is a Linux Shell command to convert a file in a hexadecimal
                            # representation
                            #                                                           *
                            # Example (one row is 60 hex. chars -> 30 Bytes):
                            # 0a0a0a48616c6c6f20426173746920756e642048656c6c692c0a0a496368
                            # 2077c3bc6e7363686520657563682065696e656e206672c3b66865205765
                            # 6963686e61636874656e21200a0a5669656c6520467265756e64652c2045
                            # 72666f6c6720756e6420476573756e64686569742066c3bc722032303139
                            # 2e0a0a45757265204a6f68616e6e0a

                            os.system(f'xxd -p {path_file} >/tmp/kodbild.tmp')

                            i_width_model = 240
                            i_height_model = 160

                            # current temporary (tmp) directory on Linux and wn
                            path_dir_temp = (tempfile.gettempdir())

                            path_file_tmp = os.path.join(path_dir_temp, "kodbild.tmp")

                            file_tmp = open(path_file_tmp, "r")

                            try:
                                str_hexa_all = ""
                                for line in file_tmp:
                                    # '000000000000000000000000000000\n' will be '000000000000000000000000000000'
                                    str_text = line.strip()

                                    str_hexa_all += str_text
                            except:
                                print("Put all hexadecimal in string is not possible")

                            # Paste the Binary of the File - Black for one and white for zero - in the
                            # PNG For the last PNG - Black for one and yellow for zero
                            object_implement = Implement_binary()

                            object_implement.implement_binary(str_hexa_all, i_width_model, i_height_model,
                                                              file_name_without_extension, str_extension,
                                                              path_dir_code_decode, str_answer)

                            try:
                                os.remove(path_file)
                            except:
                                print(f"cannot remove {path_file}")

        if nothing_to_code == True:

            print("Nothing to code")

