#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import os
import variable
from os import path
from PIL import Image
from pathlib import Path
from variable import list_format
from bin_to_hex import Bin_to_hex
from algo_decode import Algo_decode


class Decode():

    def decode(self, path_dir_code_decode):

        # variable for gif
        b_last_picture = False

        list_file_to_delete = []

        dirs = os.listdir(path_dir_code_decode)

        list_path_file = []

        # all the files and directories
        for file in dirs:

            path_file_dk = path.join(path_dir_code_decode, file)
            # only files
            if path.isfile(path_file_dk):

                if "." in file and "_" in file and len(file) > 4:

                    index = file.find('_')

                    # jpg or jpeg
                    str_beginn = file[:index].lower()

                    # png or gif
                    str_extension = file[-3:].lower()

                    # mixing pixel
                    # png_pic.png
                    #
                    # mixing bits
                    # pdf_test.gif
                    if str_beginn in list_format and ("png" in str_extension or "gif" in str_extension):
                        list_path_file.append(path_file_dk)

        list_path_file.sort()

        if len(list_path_file) > 0:

            str_total_hex = ""

            while len(list_path_file) > 0:

                if len(list_path_file) == 1:
                    b_last_picture = True

                elif len(list_path_file) >= 2:
                    basename_one = path.basename(list_path_file[0])
                    basename_two = path.basename(list_path_file[1])

                    extract_name_one = basename_one[4:-9]
                    extract_name_two = basename_two[4:-9]

                    if extract_name_one == extract_name_two:
                        b_last_picture = False
                    else:
                        b_last_picture = True

                file_name = path.basename(list_path_file[0])

                # with point - can only be .png or .gif
                str_ext = file_name[-4:]

                print("picture will decode : ", file_name)

                # pixel are mixed
                if ".png" in str_ext:

                    im = Image.open(list_path_file[0])

                    pix = im.load()

                    Algo_decode.algo_decode(pix, variable.key_900_2, 1, "900")
                    Algo_decode.algo_decode(pix, variable.key_900_2, 0, "900")
                    Algo_decode.algo_decode(pix, variable.key_900_1, 1, "900")
                    Algo_decode.algo_decode(pix, variable.key_900_1, 0, "900")

                    index = file_name.find('_')

                    str_name_without_prefix = file_name[index + 1:]

                    path_file_after_decode = path.join(path_dir_code_decode, str_name_without_prefix)

                    im.save(path_file_after_decode)

                    im.close

                    try:
                        os.remove(list_path_file[0])
                        del list_path_file[0]
                    except:
                        print(f"cannot delete png {list_path_file[0]}")


                # bits are mixed
                elif ".gif" in str_ext:

                    string_binary = ""
                    b_60_40 = False

                    x_coor = 0
                    y_coor = 0

                    # gif 60 x 40 px - all white            is 104 bytes
                    # gif 60 x 40 px - mixt white and black is 214 bytes
                    # gif 60 x 40 px - mixt white and black is 112 bytes
                    #
                    # check if size is smaller than 3000 Bytes
                    if Path(list_path_file[0]).stat().st_size < 3_000:
                        b_60_40 = True
                        x_coor = 60
                        y_coor = 40
                    else:
                        x_coor = 1_350
                        y_coor = 900

                    im = Image.open(list_path_file[0])

                    pix = im.load()

                    if b_60_40 == True:

                        Algo_decode.algo_decode(pix, variable.key_40_2, 1, "40")
                        Algo_decode.algo_decode(pix, variable.key_40_2, 0, "40")
                        Algo_decode.algo_decode(pix, variable.key_40_1, 1, "40")
                        Algo_decode.algo_decode(pix, variable.key_40_1, 0, "40")

                    else:

                        Algo_decode.algo_decode(pix, variable.key_900_2, 1, "900")
                        Algo_decode.algo_decode(pix, variable.key_900_2, 0, "900")
                        Algo_decode.algo_decode(pix, variable.key_900_1, 1, "900")
                        Algo_decode.algo_decode(pix, variable.key_900_1, 0, "900")

                    # 1350px x 900px -> 1_215_000 bits -> 151_875 Bytes
                    #   60px x  40px ->     2_400 bits ->     300 Bytes
                    #
                    # this loop put the whole decoded gif kodbild in a string
                    # black is 0
                    # white is 1
                    # value for string_binary example : '001100000001....'
                    for y in range(0, y_coor):

                        for x in range(0, x_coor):

                            str_b = str(pix[x, y])

                            string_binary += str_b

                    obj_bin_to_hex = Bin_to_hex()

                    str_hex = obj_bin_to_hex.bin_to_hex(string_binary)

                    str_total_hex += str_hex

                    im.close

                    if b_last_picture == True:
                        file_name_for_final = list_path_file[0]

                    list_file_to_delete.append(list_path_file[0])

                    # remove from list
                    del list_path_file[0]

                    if b_last_picture == True:

                        # write the entcrypted file

                        file_name_extraction = path.basename(file_name_for_final)

                        index = file_name_extraction.find('_')

                        beginn_for_extension = file_name_extraction[:index]

                        name_file_final = f"{file_name_extraction[index + 1:-9]}.{beginn_for_extension}"

                        # level up from running script
                        path_one_level_up = Path(__file__).parents[1]

                        path_file_tmp = path.join(path_one_level_up, 'temp_file.txt')

                        path_file_final = path.join(path_dir_code_decode, name_file_final)

                        try:

                            # 60.13 seconds
                            f = open(path_file_tmp, 'x')
                            f.write(str_total_hex)
                            f.close()

                            # 74.57 seconds
                            # write 60 chars per line - useful to compare with output in shell xxd -p <file>
                            #with open(path_file_tmp, 'x') as file:
                            #    file.write(textwrap.fill(str_total_hex, width=60))

                            # reset
                            str_total_hex = ""

                            os.system(f'xxd -p -r {path_file_tmp} >{path_file_final}')

                            os.remove(path_file_tmp)

                        except:
                            print("error while writing or deleting tmp file")

                        try:
                            # remove decoded file
                            for each in list_file_to_delete:
                                os.remove(each)

                            # initialization of null
                            list_file_to_delete = []

                        except:
                            print(f"Error while deleting file {list_path_file[0]}")


        else:

            print("Put some files to decode ...")
            return
