#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from cv2 import cv2
from PIL import Image


class Format_size_picture():

    def format_size_picture(self, path_file):

        image = Image.new('RGB', (1350, 900), (0, 0, 0))

        img = cv2.imread(path_file, cv2.IMREAD_UNCHANGED)

        width_actuel_img = img.shape[1]
        height_actuel_img = img.shape[0]

        if width_actuel_img > 1350 or height_actuel_img > 900:

            scale_percent = 1

            # first loop scale with one percent
            # second loop scale with two percent
            # second loop scale with three percent
            # and so on
            #
            # check the size each time
            # if size too big, break and take the last value -1
            while True:


                width = int(img.shape[1] * scale_percent / 100)
                height = int(img.shape[0] * scale_percent / 100)

                if width > 1350 or height > 900:
                    width = int(img.shape[1] * (scale_percent - 1) / 100)
                    height = int(img.shape[0] * (scale_percent - 1) / 100)
                    break
                else:
                    scale_percent += 1

            # dsize is tuple for example (1347, 500)
            dsize = (width, height)

            offset_width = int((1350 - width) / 2)
            offset_height = int((900 - height) / 2)

            # resize image
            resized_img = cv2.resize(img, dsize)

            cv2.imwrite(path_file, resized_img)

            # open the file and "load" the image in one statement
            im = Image.open(path_file)

            back_im = image.copy()
            back_im.paste(im, (offset_width, offset_height))

            back_im.save(path_file)

        elif width_actuel_img < 1350 or height_actuel_img < 900:

            scale_percent = 1

            while True:

                width = int(img.shape[1] * scale_percent / 100)
                height = int(img.shape[0] * scale_percent / 100)

                if width > 1350 or height > 900:
                    width = int(img.shape[1] * (scale_percent - 1) / 100)
                    height = int(img.shape[0] * (scale_percent - 1) / 100)
                    break
                else:
                    scale_percent += 1

            # dsize is tuple for example (1347, 500)
            dsize = (width, height)

            offset_width = int((1350 - width) / 2)
            offset_height = int((900 - height) / 2)

            # resize image
            resized_img = cv2.resize(img, dsize)

            cv2.imwrite(path_file, resized_img)

            # open the file and "load" the image in one statement
            im = Image.open(path_file)

            back_im = image.copy()
            back_im.paste(im, (offset_width, offset_height))

            back_im.save(path_file)
