#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
import os

import cv2
from PIL import Image
import variable
from algo_code import Algo_code
from os import path
import hashlib
from PIL import Image

class Implement_binary():

    def implement_binary(self, str_hexa_all, i_width_model, i_height_model, file_name_without_extension, str_extension,
                         path_two_level_up, str_for_size):

        # iIncrement creates numbers like 0 1 2 ... Then the file will takes the name
        # jpg_name00001.gif, jpg_name00002.gif ...
        i_increment_number_file_name = 1
        counter_used = 0
        b_last_picture = False
        bits = 0

        # one image is 1350 px X 900 px = 1 215 000 bits / 8 = 151_875 Bytes x 2 Chars = 303_750
        if str_for_size == "0":
            loop_picture = 303_750
            bits = 1_215_000

        # one image is 60 px X 40 px = 2 400 bits / 8 = 300 Bytes x 2 Chars = 600
        # one image is (320 px X 160 px)/4 = 2 400 bits / 8 = 300 Bytes x 2 Chars = 600    Note: 1 bit is 4 px X 4 px
        elif str_for_size == "2":
            loop_picture = 600
            bits = 2_400

        while True:

            # Format iIncrement 1 in 0001, 2 in 0002 ... Max 9999
            str_formated_number = f"{i_increment_number_file_name:05d}"

            str_prefix = str_extension

            # gif  1.1 mb
            # png  330 kb
            # tif  3.6 mb
            # tga  3.6 mb
            # webp 790 kb

            str_name_after_code = f"{str_prefix}_{file_name_without_extension}{str_formated_number}.gif"

            # txt_test00001.gif
            path_file_after_code = path.join(path_two_level_up, str_name_after_code)
            # less than one image - one image is 151_875 Bytes x 2 Chars = 303_750

            #                        loop_picture = 600 OR 303_750
            if (len(str_hexa_all) - counter_used) <= loop_picture:
                b_last_picture = True
                loop_picture = len(str_hexa_all) - counter_used

            # new white image
            if b_last_picture == True:
                # color bg yellow
                img = Image.new('RGB', (i_width_model, i_height_model), (255, 255, 0))

            else:
                # color bg white
                img = Image.new('RGB', (i_width_model, i_height_model), (255, 255, 255))

            pix = img.load()

            color_black = (0, 0, 0)

            # INITIALIZATION
            # for i_height == 900 - One image has 1_215_000 bits - needs array with size 1_215_000
            # or
            # for i_height == 40 - One image has 2_400 bits - needs array with size 2_400
            lst = []
            for i in range(0, bits):
                lst.append(0)

            iCount = 0

            if str_for_size == "0":
                # offset to catch the right character in string
                # in this case 303_750 must be hard coded - JMF
                offset = (i_increment_number_file_name - 1) * 303_750

            # 60 bit x 40 bit
            elif str_for_size == "2":
                offset = (i_increment_number_file_name - 1) * 600

            # 303750 or 600
            for i in range(0, loop_picture):

                if str_hexa_all[i + offset] == '0':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == '1':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == '2':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == '3':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == '4':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == '5':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == '6':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == '7':

                    lst[0 + iCount] = '0'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == '8':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == '9':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == 'a':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == 'b':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '0'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == 'c':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == 'd':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '0'
                    lst[3 + iCount] = '1'

                    iCount += 4

                elif str_hexa_all[i + offset] == 'e':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '0'

                    iCount += 4

                elif str_hexa_all[i + offset] == 'f':

                    lst[0 + iCount] = '1'
                    lst[1 + iCount] = '1'
                    lst[2 + iCount] = '1'
                    lst[3 + iCount] = '1'

                    iCount += 4

                counter_used += 1

            counter_increment_pixel = 0
            offset_X = 0
            offset_Y = 0

            tmp_height = i_height_model
            tmp_width = i_width_model

            # 160 px with one bit 4 px is total 40 bit
            # 60 x 40 bit
            if i_height_model == 160:
                tmp_height = int(i_height_model / 4)
                tmp_width = int(i_width_model / 4)

            if i_height_model == 160:
                for Y in range(0, tmp_height):

                    for X in range(0, tmp_width):

                        if lst[counter_increment_pixel] == "1":
                            pix[offset_X, offset_Y] = color_black
                            pix[offset_X + 1, offset_Y] = color_black
                            pix[offset_X + 2, offset_Y] = color_black
                            pix[offset_X + 3, offset_Y] = color_black

                            pix[offset_X, offset_Y + 1] = color_black
                            pix[offset_X + 1, offset_Y + 1] = color_black
                            pix[offset_X + 2, offset_Y + 1] = color_black
                            pix[offset_X + 3, offset_Y + 1] = color_black

                            pix[offset_X, offset_Y + 2] = color_black
                            pix[offset_X + 1, offset_Y + 2] = color_black
                            pix[offset_X + 2, offset_Y + 2] = color_black
                            pix[offset_X + 3, offset_Y + 2] = color_black

                            pix[offset_X, offset_Y + 3] = color_black
                            pix[offset_X + 1, offset_Y + 3] = color_black
                            pix[offset_X + 2, offset_Y + 3] = color_black
                            pix[offset_X + 3, offset_Y + 3] = color_black

                        offset_X += 4
                        counter_increment_pixel += 1

                    offset_X = 0
                    offset_Y += 4

            elif i_height_model == 900:

                for Y in range(0, tmp_height):

                    for X in range(0, tmp_width):

                        if lst[counter_increment_pixel] == "1":
                            pix[X, Y] = color_black

                        counter_increment_pixel += 1

            if str_for_size == "0":
                Algo_code.algo_code(pix, variable.key_900_1, 0, "900")
                Algo_code.algo_code(pix, variable.key_900_1, 1, "900")
                Algo_code.algo_code(pix, variable.key_900_2, 0, "900")
                Algo_code.algo_code(pix, variable.key_900_2, 1, "900")

            # 60 bit x 40 bit
            elif str_for_size == "2":
                Algo_code.algo_code(pix, variable.key_40_1, 0, "160")
                Algo_code.algo_code(pix, variable.key_40_1, 1, "160")
                Algo_code.algo_code(pix, variable.key_40_2, 0, "160")
                Algo_code.algo_code(pix, variable.key_40_2, 1, "160")

            i_increment_number_file_name += 1

            # 1350 x900
            if str_for_size == "0":

                img.save(path_file_after_code)

            # 60 bit x 40 bit
            elif str_for_size == "2":

                # create a white image with X 240 + 160 = 400 and Y 160 + 160 = 320
                img_mask = Image.new('RGB', (400, 320), (255, 255, 255))
                pixel_mask = img_mask.load()
                str_binary = ""
                count = 0
                # (255,255,0) is yellow
                # (0,0,0) is black
                for y in range(0, 160):

                    for x in range(0, 240):

                        color = pix[x, y]

                        # yellow or white
                        if color == (255, 255, 0) or color == (255, 255, 255):
                            str_binary += "0"
                            count += 1
                            pixel_mask[x + 80, y + 80] = color
                        # black
                        elif color == (0, 0, 0):
                            str_binary += "1"
                            count += 1
                            pixel_mask[x + 80, y + 80] = color

                # for debug purpose
                # print(str_binary)
                # print(f"count {count}")

                # make md5sum from string
                m = hashlib.md5()
                m.update(str_binary.encode('utf-8'))
                str_md5 = m.hexdigest()
                print(f"md5sum from str_binary : {str_md5}")

                color_black_ = (0, 0, 0)
                # draw square top left
                for y in range(0, 20):
                    for x in range(0, 20):
                        pixel_mask[x + 60, y + 60] = color_black_

                # draw square top right
                for y in range(0, 20):
                    for x in range(0, 20):
                        pixel_mask[x + 320, y + 60] = color_black_

                # draw square bottom right
                for y in range(0, 20):
                    for x in range(0, 20):
                        pixel_mask[x + 320, y + 240] = color_black_

                # draw square bottom left
                for y in range(0, 20):
                    for x in range(0, 20):
                        pixel_mask[x + 60, y + 240] = color_black_

                img_mask.save(path_file_after_code)

                part_md5 = str_md5[:4]

                # convert png

                str_name_png = f"{str_prefix}_{file_name_without_extension}{str_formated_number}.png"

                # txt_test00001.png
                path_file_png = path.join(path_two_level_up, str_name_png)

                img = Image.open(path_file_after_code)

                rgb_image = img.convert('RGB')

                rgb_image.save(path_file_png)

                # end convert png

                # write text

                image = cv2.imread(path_file_png, cv2.IMREAD_UNCHANGED)

                position = (30, 30)

                cv2.putText(image, part_md5, (30, 40), cv2.FONT_HERSHEY_SIMPLEX, 0.8, (0, 0, 0), 1)

                cv2.putText(image, '11235@kodbild.com', (30, 300), cv2.FONT_HERSHEY_SIMPLEX, 0.8, (0, 0, 0), 1)

                cv2.imwrite(path_file_png, image)

                s = path_file_png

                d = path_file_after_code

                cmd = f'convert {s} {d}'

                # use shell and use convert from imagemagick
                os.system(cmd)

                # overwrite the existing file
                os.remove(path_file_png)


            if b_last_picture == True:
                break
