#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import time
import os
import sys
import hashlib
import variable
from os import path
from seed import Seed
from pathlib import Path
from code_k import Code_k
from decode import Decode
from xml_set import Xml_set
from xml_read import Xml_read
from make_key import Make_key
from xml_write import Xml_write
from xml_remove import Xml_remove
from xml_append import Xml_append
from xml_extract import Xml_extract

def main(argument_1):

    path_force = 0
    path_dir_destination_after_code_for_voice = ""

    if argument_1 != "nothing":
        # for use kodbild automatic with argument
        friend = int(argument_1[0])
        action = int(argument_1[1])
        # 0 not force    1 force
        path_force = int(argument_1[2])

    here = Path(__file__).resolve()

    # level up from running script
    path_one_level_up = here.parents[1]

    if path_force == 0:
        # not force - level up from running script
        path_dir_code_decode = here.parents[2]

    elif path_force == 1:
        # will be force
        path_part = here.parents[2]
        path_dir_code_decode = os.path.join(path_part,'voice_recordings_ogg')
        path_dir_destination_after_code_for_voice = os.path.join(path_part, 'voice_recordings_encrypted')

    path_file_xml = path.join(path_one_level_up, "abc.xml")

    path_dir_config = path.join(path_one_level_up, "config")

    path_file_config = path.join(path_dir_config, "config.txt")

    try:
        if path.isdir(path_dir_config) == False:
            os.mkdir(path_dir_config)
            print(f"Config directory created: {path_dir_config}")
    except:
        print(f"Cannot create {path_dir_config}")

    if path.isfile(path_file_config) == False:
        try:
            carriage_retour = "\r\n"
            f = open(path_file_config, "w+")
            f.write(f"# Config file for program Kodbild{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"# default path if empty: two levels higher{carriage_retour}")
            f.write(f"#{carriage_retour}")
            f.write(f"# example path: /home/bob/Desktop/kodbild{carriage_retour}")
            f.write(f"path_dir_processing={carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"# yes or no{carriage_retour}")
            f.write(f"keep_history_recording=yes{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"path_file_recordings_gnome_sound_recorder={carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"server_name={carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"server_port={carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"email_login_name={carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"email_password={carriage_retour}")
            f.write(f"{carriage_retour}")
            f.write(f"{carriage_retour}")
            f.close()

            print(f"Config file created: {path_file_config}")
            print()
        except:
            print(f"Cannot create {path_file_config}")

    else:
        # read file and attribute the path variable
        file_conf = open(path_file_config, 'r')

        lines_conf = file_conf.readlines()

        for line in lines_conf:

            str_line = line.strip()
            start_line = str_line[:20]
            if start_line == "path_dir_processing=" and path_force == 0:
                end_line = str_line[20:]
                # not empty - go in it
                if len(end_line) > 0:
                    # check if the given directory path for code / decode the pictures exist
                    if path.isdir(end_line) == False:
                        print(f"Please check the path: {end_line} in {path_file_config}")
                        print("program will exit ...")
                        exit(0)
                    else:
                        path_dir_code_decode = end_line

    if argument_1 == "nothing":
        count_for_message = 0
        while True:
            carriage = "\n"


            print()

            if count_for_message == 0:
                print(f"This program comes with ABSOLUTELY NO WARRANTY; This is free software, and you {carriage}"
                      f"are welcome to redistribute it under certain condition.{carriage}"
                      f"www.kodbild.com ---------------------------------------------Free/libre Software{carriage}")
                count_for_message += 1

            print(f"{carriage}"
                    f"Main Menu                                                               Version {variable.version}{carriage}"
                    f"{carriage}"
                    f"< N >       Create contact{carriage}"
                    f"{carriage}"
                    f"< X >       Delete contact{carriage}"
                    f"{carriage}"
                    f"< NUMBER >  Load contact{carriage}"
                    f"{carriage}"
                    f"< Info >    Print path of the directory for code and decode{carriage}"
                    f"{carriage}"
                    f"< . >       Exit{carriage}"
                    f"{carriage}")

            list_name = []

            if path.exists(path_file_xml):
                obj_read = Xml_read()
                list_name = obj_read.xml_read_only_friend()

            counter = 1
            if list_name is not None:
                for each in list_name:
                    print(f"< {counter} > {list_name[counter - 1]}")
                    counter += 1

            answer_value = input("").lower()

            bool_answer_is_a_number = True
            try:
                int_value = int(answer_value)
            except:
                bool_answer_is_a_number = False

            if bool_answer_is_a_number == True:
                # if input number is bigger than list -1
                # pass (ignore the rest of the program und go to the begin of the while True)
                if int_value <= len(list_name):
                    pass
                else:
                    continue



                while True:

                    name = list_name[int_value - 1]

                    obj_xml_extract = Xml_extract()
                    obj_xml_extract.xml_extract(int_value - 1, name)

                    seed_1 = variable.passphrase_seed_1
                    seed_2 = variable.passphrase_seed_2

                    start_seed_1 = seed_1[:10]
                    start_seed_2 = seed_2[:10]

                    if len(seed_1) > 10:
                        start_seed_1 = f"{seed_1[:8]}.."

                    if len(seed_2) > 10:
                        start_seed_2 = f"{seed_2[:8]}.."

                    str_format_seed_1 = '{:>10}'.format(start_seed_1)
                    str_format_seed_2 = '{:>10}'.format(start_seed_2)

                    var_loop_seed_1_seed_2 = str(variable.loop) + start_seed_1 + start_seed_2

                    str_md5= hashlib.md5(var_loop_seed_1_seed_2.encode('utf-8')).hexdigest()

                    start_md5 = f"{str_md5[:4]}.."

                    print()

                    print(
                        f"Friend : {name}       loop : {variable.loop}       seed_1: {str_format_seed_1}       seed_2: {str_format_seed_2}       md5: {start_md5}")

                    print()

                    print("< 0 >  code - gif")

                    print("< 1 >  code - mixing png")

                    print("< 2 >  code - format 60x40 - beta")

                    print("< 3 >  decode")

                    print("< 4 >  change loop")

                    print("< 5 >  change seed")

                    print("< . >  exit")

                    answer = input("")

                    # gif
                    if answer == "0":
                        start = time.time()
                        obj_code_k = Code_k()
                        obj_code_k.code_k("0", path_dir_code_decode, path_dir_destination_after_code_for_voice)
                        end = time.time()
                        print()
                        print(f"Code in {round(end - start,2)} seconds")


                    # mixing pixel
                    elif answer == "1":
                        start = time.time()
                        obj_code_k = Code_k()
                        obj_code_k.code_k("1", path_dir_code_decode, path_dir_destination_after_code_for_voice)
                        end = time.time()
                        print()
                        print(f"Code in {round(end - start,2)} seconds")

                    # format 60 x 40
                    elif answer == "2":
                        start = time.time()
                        obj_code_k = Code_k()
                        obj_code_k.code_k("2", path_dir_code_decode,path_dir_destination_after_code_for_voice)
                        end = time.time()
                        print()
                        print(f"Code in {round(end - start,2)} seconds")

                    elif answer == "3":
                        start = time.time()
                        obj_decode = Decode()
                        obj_decode.decode(path_dir_code_decode)
                        end = time.time()
                        print()
                        print(f"Decode in {round(end - start,2)} seconds")

                    elif answer == "4":

                        while True:

                            print("< . > go back")
                            print()
                            print(f"Give a new value for loop [ 0 - {variable.loop_max_code_decode} ], then enter")
                            answer = input("")

                            if answer == ".":
                                break

                            # if not number make an exception but don't stop
                            try:
                                i_answer = int(answer)
                            except:
                                print("error")
                                print()
                                print()
                                continue

                            if i_answer <= variable.loop_max_code_decode:
                                obj_xml_set = Xml_set()
                                obj_xml_set.xml_set(name, 2, answer)
                                print("Loop updated")
                                break

                    elif answer == "5":

                        while True:

                            print("< . > go back")
                            print()
                            print(f"Give seed one, then enter")
                            answer_1 = input("")
                            print()
                            print(f"Give seed two, then enter")
                            answer_2 = input("")
                            print()

                            if answer == ".":
                                break

                            # delete seed_1.txt
                            try:
                                path_file_seed_1 = path.join(path_one_level_up, "seed_1.txt")
                                os.remove(path_file_seed_1)
                            except:
                                print(f"cannot delete file {path_file_seed_1}")

                            # delete seed_2.txt
                            try:
                                path_file_seed_2 = path.join(path_one_level_up, "seed_2.txt")
                                os.remove(path_file_seed_2)
                            except:
                                print(f"cannot delete file {path_file_seed_2}")

                            # create files seed_1.txt and seed_2.txt
                            seed_obj = Seed()
                            seed_obj.seed("1", answer_1)
                            seed_obj.seed("2", answer_2)

                            obj_make_key = Make_key()

                            key_40_1 = obj_make_key.make_key(1, "40")
                            key_40_2 = obj_make_key.make_key(2, "40")
                            key_900_1 = obj_make_key.make_key(1, "900")
                            key_900_2 = obj_make_key.make_key(2, "900")
                            key_2160_1 = obj_make_key.make_key(1, "2160")
                            key_2160_2 = obj_make_key.make_key(2, "2160")



                            obj_xml_set = Xml_set()
                            obj_xml_set.xml_set(name, 0, answer_1)
                            obj_xml_set.xml_set(name, 1, answer_2)
                            obj_xml_set.xml_set(name, 3, key_40_1)
                            obj_xml_set.xml_set(name, 4, key_40_2)
                            obj_xml_set.xml_set(name, 5, key_900_1)
                            obj_xml_set.xml_set(name, 6, key_900_2)
                            obj_xml_set.xml_set(name, 7, key_2160_1)
                            obj_xml_set.xml_set(name, 8, key_2160_2)
                            print()
                            print("Seed one and seed two, updated")
                            print()
                            break


                    elif answer == ".":
                        break
                    else:
                        pass

            elif answer_value == "n" and bool_answer_is_a_number == False:
                print()
                print("Please give, for a new contact, a name or an E-mail address, then enter:")
                name_or_mail = input("")

                print()
                print("Please give the first seed, then enter")
                first_seed = input("")

                print()
                print("Please give the second seed, then enter")
                second_seed = input("")

                print()
                print("Please give loop [0 to 35_000], then enter")
                loop = input("")

                # create files seed_1.txt and seed_2.txt
                seed_obj = Seed()
                seed_obj.seed("1", first_seed)
                seed_obj.seed("2", second_seed)

                obj_make_key = Make_key()

                key_40_1 = obj_make_key.make_key(1, "40")
                key_40_2 = obj_make_key.make_key(2, "40")
                key_900_1 = obj_make_key.make_key(1, "900")
                key_900_2 = obj_make_key.make_key(2, "900")
                key_2160_1 = obj_make_key.make_key(1, "2160")
                key_2160_2 = obj_make_key.make_key(2, "2160")

                if path.exists(path_file_xml):
                    obj_xml_append = Xml_append()
                    obj_xml_append.xml_append(name_or_mail, first_seed, second_seed, loop, key_40_1, key_40_2, key_900_1,
                                              key_900_2, key_2160_1, key_2160_2)

                else:
                    # create xml file
                    obj_xml_write = Xml_write()
                    obj_xml_write.xml_write(name_or_mail, first_seed, second_seed, loop, key_40_1, key_40_2,
                                            key_900_1, key_900_2, key_2160_1, key_2160_2)
                    print("XML file created")

            elif answer_value == "x" and bool_answer_is_a_number == False:

                while True:

                    obj_read = Xml_read()
                    list_name = obj_read.xml_read_only_friend()

                    # list is not empty
                    if len(list_name) > 0:

                        print()
                        print("To delelete a friend, tipp the number and enter...")
                        print()
                        print("< . > go back")
                        print()

                        counter = 1
                        for each in list_name:
                            print(f"<{counter}> {list_name[counter - 1]}")
                            counter += 1

                        answer = input("")

                        bool_answer_is_a_number = True
                        try:
                            int_value = int(answer)
                        except:
                            bool_answer_is_a_number = False

                        if bool_answer_is_a_number == True:
                            if int_value <= len(list_name):
                                pass
                            else:
                                continue

                        if answer == ".":
                            break

                        elif bool_answer_is_a_number:

                            name = list_name[int_value - 1]

                            obj_xml_remove = Xml_remove()
                            obj_xml_remove.xml_remove(name)



                    else:
                        print()
                        print()
                        print("No contact to remove...")
                        print()
                        time.sleep(2)
                        break

            elif answer_value == "info" and bool_answer_is_a_number == False:
                print(f"Path dir for code and decode: {path_dir_code_decode}")
                print()

    else:

        # for use kodbild automatic with argument

        list_name = []

        if path.exists(path_file_xml):
            obj_read = Xml_read()
            list_name = obj_read.xml_read_only_friend()


        if list_name is not None:

            if action == 0 or action == 1 or action == 3:

                if friend > len(list_name):
                    print(f"Number is out of the range of friends, program will exit")
                    time.sleep(3)
                    exit(1)
                name = list_name[friend - 1]

                obj_xml_extract = Xml_extract()
                obj_xml_extract.xml_extract(friend - 1, name)

                print(f"friend: {name}")

                # gif
                if action == 0:


                    start = time.time()
                    obj_code_k = Code_k()
                    obj_code_k.code_k("0", path_dir_code_decode, path_dir_destination_after_code_for_voice)
                    end = time.time()
                    print()
                    print(f"Code in {round(end - start, 2)} seconds")

                # mixing pixels
                elif action == 1:
                    start = time.time()
                    obj_code_k = Code_k()
                    obj_code_k.code_k("1", path_dir_code_decode, path_dir_destination_after_code_for_voice)
                    end = time.time()
                    print()
                    print(f"Code in {round(end - start, 2)} seconds")

                # decode
                elif action == 3:
                    start = time.time()
                    obj_decode = Decode()
                    obj_decode.decode(path_dir_code_decode)
                    end = time.time()
                    print()
                    print(f"Decode in {round(end - start, 2)} seconds")
            else:
                print(f"action <<{action}>> is not available, program will exit")
                time.sleep(3)
                exit(1)

        else:
            print("No friend are available, program will exit")
            time.sleep(3)
            exit(1)


if __name__ == "__main__":

    if len(sys.argv) == 1:
        main("nothing")
    elif len(sys.argv) == 2:
        main(sys.argv[1])


    else:
        print("two much arguments, program will close")
        time.sleep(3)
        exit(1)

