#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from variable import loopmax
from os import path
from pathlib import Path


class Make_key():

    def make_key(self, str_nummer, str_format):

        # level up from running script
        path_one_level_up = Path(__file__).parents[1]

        file_name = ""

        string_buffer = ""

        string_data = ""

        if str_nummer == 1:
            file_name = "seed_1.txt"
        elif str_nummer == 2:
            file_name = "seed_2.txt"

        path_file_seed = path.join(path_one_level_up, file_name)

        if path.isfile(path_file_seed):
            with open(path_file_seed, 'r') as file:
                string_data = file.read().replace('\n', '')

        i_width_model = 0
        i_height_model = 0

        if str_format == "40":
            i_width_model = 60
            i_height_model = 40
        elif str_format == "900":
            i_width_model = 1350
            i_height_model = 900
        elif str_format == "2160":
            i_width_model = 3840
            i_height_model = 2160

        # format 60 x 40 px
        if str_format == "40":
            i_min_square = 3
        else:
            # for example 900 / 15 = 60
            i_min_square = int(i_height_model / 15)

        i_count = 0

        i_share = 0

        str_width = ""
        str_height = ""
        str_square = ""

        loop_maxi = loopmax

        for i in range(0, loop_maxi):



            str_width = string_data[0 + i_count: 3 + i_count]
            i_width = int(str_width)

            str_height = string_data[3 + i_count: 6 + i_count]
            i_height = int(str_height)

            str_square = string_data[6 + i_count: 9 + i_count]
            i_square = int(str_square)

            i_count += 9

            if i_height_model == 40:
                #i_width = int(i_width /50)
                #i_height = int(i_height /50)
                #i_square = int(i_square / 50)

                value = 33
                i_width = int(i_width / value)
                i_height = int(i_height / value)
                i_square = int(i_square / value)


            if i_height_model == 40 or i_height_model == 900:

                if (i_width + i_square <= i_width_model - 1) and (i_height + i_square <= i_height_model - 1) and (
                        i_square > i_min_square):

                    # leading zero - 5 will be 005

                    formatted_width = "{:03d}".format(i_width)
                    formatted_height = "{:03d}".format(i_height)
                    formatted_square = "{:03d}".format(i_square)

                    string_buffer += f"{formatted_width}{formatted_height}{formatted_square}"

                else:
                    loop_maxi += 1


            elif  i_height_model == 2160:

                if i_share == 0:
                    i_width += 0
                    i_height += 0
                    i_share += 1
                elif i_share == 1:
                    i_width += 1245
                    i_height += 0
                    i_share += 1
                elif i_share == 2:
                    i_width += 2490
                    i_height += 0
                    i_share += 1
                elif i_share == 3:
                    i_width += 0
                    i_height += 630
                    i_share += 1
                elif i_share == 4:
                    i_width += 1245
                    i_height += 630
                    i_share += 1
                elif i_share == 5:
                    i_width += 2490
                    i_height += 630
                    i_share += 1
                elif i_share == 6:
                    i_width += 0
                    i_height += 1260
                    i_share += 1
                elif i_share == 7:
                    i_width += 1245
                    i_height += 1260
                    i_share += 1
                elif i_share == 8:
                    i_width += 2490
                    i_height += 1260
                    i_share = 0

                # 3840 x 2160
                if (i_width + i_square <= i_width_model - 4) and (i_height + i_square <= i_height_model - 4) and (
                        i_square > i_min_square):

                    # may be 0, 4, 8, or 12 etc...
                    if i_width % 4 != 0:
                        i_width = i_width - (i_width % 4)

                    # may be 0, 4, 8, or 12 etc...
                    if i_height % 4 != 0:
                        i_height = i_height - (i_height % 4)

                    # may be 0, 4, 8, or 12 etc...
                    if i_square % 4 != 0:
                        i_square = i_square - (i_square % 4)

                    formatted_width = "{:03d}".format(i_width)
                    formatted_height = "{:03d}".format(i_height)
                    formatted_square = "{:03d}".format(i_square)

                    string_buffer += f"{formatted_width}{formatted_height}{formatted_square}"

                else:

                    loop_maxi += 1

        return string_buffer
