#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from os import path
import hashlib
import re
from pathlib import Path
import time

from print_progress_bar import print_progress_bar


class Seed():

    def seed(self, str_number, seed_plain_text):

        here = Path(__file__).resolve()

        # level up from running script
        path_one_level_up = here.parents[1]

        name_file_seed = ""

        if str_number == "1":
            name_file_seed = "seed_1.txt"

        elif str_number == "2":
            name_file_seed = "seed_2.txt"

        path_file_seed = path.join(path_one_level_up, name_file_seed)

        f = open(path_file_seed, "w")

        i_count_dot = 0

        str_symbol = ""

        count_digit = 0

        # seed.txt has 4 000 000 numbers -> ok for max 73 000 Loop Model 1 and 2
        coding = 4_000_000

        while True:

            # $ echo -n "A"  | sha256sum
            # 559aead08264d5795d3909718cdd05abd49572e84fe55590eef31a88a08fdffd
            str_sha256_value = hashlib.sha256(seed_plain_text.encode()).hexdigest()

            # permute
            # #stSeedPlainText = 559aead08264d5795d3909718cdd05abd49572e84fe55590eef31a88a08fdffd
            seed_plain_text = str_sha256_value

            str_only_number = re.sub("[^0-9]", "", str_sha256_value)

            # lCountDigit = Total all numbers
            # 559082645795390971805495728455590318808 is 39 chars
            # 728455590318808579539097180549554957284 is 39 chars
            # count_digit will be 78
            count_digit += len(str_only_number)

            i_count_dot += 1

            f.write(str_only_number)


            if count_digit > coding:
                print()
                # A List of Items
                items = list(range(0, 60))
                l = len(items)

                lenght_bar = 75
                # Initial call to print 0% progress
                print_progress_bar(0, l, prefix='Progress:', suffix='Complete', length=lenght_bar)

                for i, item in enumerate(items):
                    # Do stuff...
                    # time.sleep(0.5)
                    # Update Progress Bar
                    print_progress_bar(i + 1, l, prefix='Progress:', suffix='Complete', length=lenght_bar)
                break

        f.close()
        return True
