#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import xml.etree.ElementTree as ET
from pathlib import Path
from os import path


class Xml_append():

    def xml_append(self, name_friend, passphrase_seed_1, passphrase_seed_2, loop, key_40_1, key_40_2,key_900_1, key_900_2, key_2160_1,
                   key_2160_2):

        here = Path(__file__).resolve()

        # level up from running script
        path_one_level_up = here.parents[1]

        path_file = path.join(path_one_level_up, 'abc.xml')

        #  _            _             _             _     _
        # | |_ ___   __| | ___     __| | ___  _   _| |__ | | ___
        # | __/ _ \ / _` |/ _ \   / _` |/ _ \| | | | '_ \| |/ _ \
        # | || (_) | (_| | (_) | | (_| | (_) | |_| | |_) | |  __/
        #  \__\___/ \__,_|\___/   \__,_|\___/ \__,_|_.__/|_|\___|
        #
        #             _
        #   ___ _ __ | |_ _ __ _   _
        #  / _ \ '_ \| __| '__| | | |
        # |  __/ | | | |_| |  | |_| |
        #  \___|_| |_|\__|_|   \__, |
        #                      |___/
        # todo change this code to have one entry
        tree = ET.parse(path_file)

        root = tree.getroot()

        child_of_root_element = ET.SubElement(root, "friend", name=name_friend)

        ET.SubElement(child_of_root_element, "passphrase_seed_1").text = passphrase_seed_1
        ET.SubElement(child_of_root_element, "passphrase_seed_2").text = passphrase_seed_2
        ET.SubElement(child_of_root_element, "loop").text = loop
        ET.SubElement(child_of_root_element, "key_40_1").text = key_40_1
        ET.SubElement(child_of_root_element, "key_40_2").text = key_40_2
        ET.SubElement(child_of_root_element, "key_900_1").text = key_900_1
        ET.SubElement(child_of_root_element, "key_900_2").text = key_900_2
        ET.SubElement(child_of_root_element, "key_2160_1").text = key_2160_1
        ET.SubElement(child_of_root_element, "key_2160_2").text = key_2160_2

        root.append(child_of_root_element)

        # remove double entry
        for friend in root.findall('friend'):

            name = friend.get('name')

            if name == name_friend:
                root.remove(friend)
                break

        tree.write(path_file)
