#
#  Kodbild - Program to code and decode PNG pictures, jpg, jpeg, ogg,
#  mp3, gif, epub, pdf, odt, ods, xcf, svg, txt, mp4, webm, mkv files.
#
#  Copyright (C) 2017 Johann M. Fradin  -  www.kodbild.com
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import xml.etree.ElementTree as ET
from pathlib import Path
from os import path


class Xml_write():

    def xml_write(self, name_friend, passphrase_seed_1, passphrase_seed_2, str_loop, key_40_1, key_40_2,key_900_1, key_900_2, key_2160_1,
                  key_2160_2):
        here = Path(__file__).resolve()

        # level up from running script
        path_one_level_up = here.parents[1]

        path_file = path.join(path_one_level_up, 'abc.xml')

        # <root>
        #   <friend name="bob">
        #       <passphrase_seed_1>222</passphrase_seed_1>
        #       <passphrase_seed_2>000</passphrase_seed_2>
        #       <loop>100</loop>
        #       <key_900_1>8463856</key_900_1>
        #       <key_900_2>72384</key_900_2>
        #       <key_2160_1>3793749</key_2160_1>
        #       <key_2160_2>7923447</key_2160_2>
        #   </friend>
        #
        #   <friend name="alice">
        #       <passphrase_seed_1>666</passphrase_seed_1>
        #       <passphrase_seed_2>1010</passphrase_seed_2>
        #       <loop>100</loop>
        #       <key_900_1>293847</key_900_1>
        #       <key_900_2>24938</key_900_2>
        #       <key_2160_1>793847</key_2160_1>
        #       <key_2160_2>0928437</key_2160_2>
        #       </friend>
        # </root>

        # w for create or overwrite
        f = open(path_file, "w")

        f.close()

        root = ET.Element("root")

        tree = ET.ElementTree(root)

        et_sub = ET.SubElement(root, "friend", name=name_friend)

        ET.SubElement(et_sub, "passphrase_seed_1").text = passphrase_seed_1
        ET.SubElement(et_sub, "passphrase_seed_2").text = passphrase_seed_2
        ET.SubElement(et_sub, "loop").text = str_loop
        ET.SubElement(et_sub, "key_40_1").text = key_40_1
        ET.SubElement(et_sub, "key_40_2").text = key_40_2
        ET.SubElement(et_sub, "key_900_1").text = key_900_1
        ET.SubElement(et_sub, "key_900_2").text = key_900_2
        ET.SubElement(et_sub, "key_2160_1").text = key_2160_1
        ET.SubElement(et_sub, "key_2160_2").text = key_2160_2

        tree.write(path_file)
